//Pico_PWM2
#include "pico/stdlib.h"
#include "hardware/pwm.h"
#include <stdio.h>
#include "hardware/clocks.h"
const float test_duty_cycles[] = {
        0.f,
        0.1f,
        0.5f,
        0.9f,
        1.f
};


// This example drives a PWM output at a range of duty cycles, and uses
// another PWM slice in input mode to measure the duty cycle. You'll need to
// connect these two pins with a jumper wire:
const uint OUTPUT_PIN = 2;
const uint MEASURE_PIN = 5;

float measure_duty_cycle(uint gpio) {
    // Only the PWM B pins can be used as inputs.
    assert(pwm_gpio_to_channel(gpio) == PWM_CHAN_B);
    uint slice_num = pwm_gpio_to_slice_num(gpio);

    // Count once for every 100 cycles the PWM B input is high
    pwm_config cfg = pwm_get_default_config();
    pwm_config_set_clkdiv_mode(&cfg, PWM_DIV_B_RISING);
    //pwm_config_set_clkdiv(&cfg, 100);
    pwm_init(2, &cfg, false);
    gpio_set_function(5, GPIO_FUNC_PWM);
    uint32_t t = time_us_32() + 1000;
    pwm_set_enabled(2, true);
    while (t>time_us_32());
    pwm_set_enabled(2, false);
   // float counting_rate = clock_get_hz(clk_sys) / 100;
   // float max_possible_count = counting_rate * 0.01;
    return pwm_get_counter(slice_num)  ; //max_possible_count;
}

void setup() {
    Serial.begin(115200); 
    Serial.println("PWM duty cycle measurement example");

    // Configure PWM slice and set it running
    const uint count_top = 1000;
    pwm_config cfg = pwm_get_default_config();
    pwm_config_set_wrap(&cfg, count_top);
    pwm_init(pwm_gpio_to_slice_num(OUTPUT_PIN), &cfg, true);

    // Note we aren't touching the other pin yet -- PWM pins are outputs by
    // default, but change to inputs once the divider mode is changed from
    // free-running. It's not wise to connect two outputs directly together!
    gpio_set_function(OUTPUT_PIN, GPIO_FUNC_PWM);

    // For each of our test duty cycles, drive the output pin at that level,
    // and read back the actual output duty cycle using the other pin. The two
    // values should be very close!
    while (true){
    for (int i = 0; i < count_of(test_duty_cycles); ++i) {
        float output_duty_cycle = test_duty_cycles[i];
        pwm_set_gpio_level(OUTPUT_PIN, output_duty_cycle * (count_top + 1));
        float measured_duty_cycle = measure_duty_cycle(MEASURE_PIN);
        Serial.print("Output duty cycle = ");
        Serial.print (output_duty_cycle * 100.f);
        Serial.print("  ");
        Serial.println(  measured_duty_cycle );   
        sleep_ms(500);
    }
    }
}

void loop() {
}
