//Pico_ScopeDDS2 Zweikanal  
//Kommandos: f1000, g2000, t1: 1000Hz, 2000Hz, 1ms/Skt
#include "pico/stdlib.h"
#include "hardware/adc.h"
#include "hardware/pwm.h"
#include "pico/multicore.h"

unsigned int scope[1000]; 
unsigned int dds[1024]; 
uint16_t akku1, akku2, i; 
unsigned int d, f1, f2, dp1, dp2, t, t0;

void setup() {
  f1=1000;
  dp1=f1*64/100;
  f2=2000;
  dp2=f2*64/100;
  Serial.begin(115200); 
  for (int j = 0; j < 1024; j++){
    dds[j]=625+400* sin(2*PI*j/1024.0);
  }
  while(true){
    if (Serial.available()){
      char ch = Serial.read();
      uint32_t d = Serial.parseInt();
      if (ch==102) dp1=d*64/100;  //f
      if (ch==103) dp2=d*64/100;  //g 
      if (ch==116) t0=d;  //t 
    }
    i=0;
    sleep_ms(1000);
    for (int j = 0; j < 500; j++){
      Serial.print ((int) scope[2*j]*3300/4095);
      Serial.print (" ");
      Serial.print ((int) scope[2*j+1]*3300/4095);
      Serial.print (" ");
      Serial.print (0);
      Serial.print (" ");
      Serial.println (3300);
    }
  }
}

void loop() {}  
  
void setup1() {
  adc_init();
  adc_gpio_init(26);
  adc_gpio_init(27);
  adc_select_input(0);    
  gpio_set_function(0, GPIO_FUNC_PWM);
  gpio_set_function(1, GPIO_FUNC_PWM);
  pwm_set_wrap(0, 1249);  //PWM 100 kHz
  pwm_set_gpio_level(0, 624);
  pwm_set_gpio_level(1, 624);
  pwm_set_enabled(0, true);
  pwm_set_irq_enabled(0, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, pwm_int); 
  irq_set_enabled(PWM_IRQ_WRAP, true);
  while (true);
}  

void pwm_int() {
  pwm_clear_irq(0);
  pwm_set_gpio_level(0,dds[akku1>>6]);
  pwm_set_gpio_level(1,dds[akku2>>6]);
  akku1+=dp1;
  akku2+=dp2;
  if(t>=t0){
    t=0;
    if (i<500){
      adc_select_input(0);
      scope[2*i]=adc_read();
      adc_select_input(1);
      scope[2*i+1]=adc_read();
      i++;
    }
  }
  t++;
}

void loop1() {}
